require "mygame/boot"

p fps
class Test
  def initialize(n)
    @logs = []
    @total = 0
    [
      "Font.render",
      "Font.render(:ABC)",
      "Font.render(:ABC, :x => 10, :y => 10)",
      "Font.render(:size, :size => 40)",
      "Font.render(:color, :color => [255,128,128])",
      "ShadowFont.render",
      "ShadowFont.render(:alpha, :size => 40, :alpha => 64)",
      "Image.render",
      "Image.render('sample.png')",
      "TransparentImage.render('sample.png')",
      "TransparentImage.render('sample.png', :alpha => 64)",
      "TransparentImage.render('sample.png', :x => 100, :y => 100, :scale => 0.5, :angle => 40)",
      "Square.render",
      "Square.render(0, 0, 50, 50)",
      "FillSquare.render(0, 0, 50, 50, :alpha => 128)",
    ].each do |expr|
      main_loop_test(n, expr)
    end

    %w(
      Font.new
      Font.new('AAA')
      ShadowFont.new
      ShadowFont.new('AAA')
      Image.new
      Image.new('sample.png')
      TransparentImage.new('sample.png')
      Square.new(0,0,50,50)
      FillSquare.new(0,0,50,50)
    ).each do |expr|
      prim = eval(expr)
      main_loop_test(n, expr) do
        prim.render
      end
    end

    prims = [
      TransparentImage.new("sample.png"),
      Square.new(0, 200, 50, 50),
      FillSquare.new(100, 200, 50, 50),
    ]
    main_loop_test(n, "render prims") do
      prims.each {|e| e.render }
    end

    puts
    puts m = "#{@total} sec : Total time"
    puts

    add_log m
    render_logs
  end

  def add_log(string)
    @logs << ShadowFont.new(string, :x => 100, :y => @logs.size * 15, :size => 14, :alpha => 128)
  end

  def render_logs
    @logs.each {|e| e.render }
  end

  N = 100
  def main_loop_test(n, name = "no name")
    set_background_color [0, 0, 64]
    add_log name
    ct = 0
    t = Time.new
    main_loop(0) do
      N.times {
          block_given? ? yield : eval(name)
      }
      render_logs
      break if n < (ct += 1)
    end
    code = block_given? ? name : "eval '#{name}'"
    puts m = "#{sec = Time.new - t} sec : #{N * n}.times { #{code} }"
    @logs.last.string = m
    @total += sec
  end
end

Test.new(1)
Test.new(10)
